/* 
 * CSE142, 98 Autumn
 * Homework 4 Part D
 * Rain Gods and Goddesses
 * Name : Wingsze Kency Liu
 * Student ID: 9733235
 * email address: kency@u.washington.edu
 ****************************************************************/

/* 
   Welcome to the land of Wonderland!! Do you want to know more 
   about the weather of this Wonderland? Then, you should take a 
   look at this program,which will give you a better view of it. 
   Sometimes the rains are accompanied with their friends, Ms. & 
   Mr. Windy! Before you do anything, try to draw some raindrops,
   snowdrops and haildrops. Watch out! you will see something 
   falling down after you press the 'WINDY' button. This animation 
   effect will only be occured at the night time.However, please 
   also pay attention to the raindrops, snowdrops and haildrops 
   after you press the 'WINDY' button in both day and night time. 
   Want to see all the animation again? Just press 'RESTART' button
   and you can re-visit the Wonderland again. Get ready for the 
   tour? Enjoy it!!
*/

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#define TRUE    		1
#define FALSE   		0

/*Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	80

/*number of buttons*/
#define NUM_BUTTONS 	10

/*color of letter on buttons*/
#define SELECTED_COLOR   RED
#define UNSELECTED_COLOR DUSTY_PLUM

/*the total number of drops possible at one time.*/
#define MAX_PRECIP_EVENTS	500
	

/*y-co ordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 8))


/*fill the shape being drawn*/
#define FILL 0

/*Types of precipitations*/
#define NONE 0
#define RAIN 1
#define SNOW 2
#define HAIL 3
#define CEASE 4

/*Types of percipitation*/
#define MAX_PRECIP_TYPES 3

/*Possible places for mouse clicks*/
#define BUTTON 1
	/*The above means you clicked on SOME button*/
#define DIRT 2
	/*The above means you clicked in the dirt area */

/*Types of animation*/
#define DAY 0
#define NIGHT 1 
#define WINDY 2

/*restart the program again*/
#define RESTART 3

/*******************  FUNCTION PROTOTYPES **************************/

/*Redraw all the buttons.
  The parameters tell which button should be highlighted
*/
void DrawButtons(int current_precip, int current_color, int day_or_night, 
				 int animation, int clear_weather);

/*Clear all precipitation, so the landscape is just as originally*/
void ClearAllPrecipitation(int precip_type[]);


/*Render (draw) all the precipitation*/
void DrawAllPrecipitation(int precip_type[], int bottom_x[], 
						  int bottom_y[], int precip_color[], 
						  int current_object);

/*Draw landscape*/
void DrawLandscape(int sun_x, int sun_y, int day_or_night, int star_x, 
				   int star_y, int n, int a, int b, int animation, int c, 
				   int s, int moon_x, int moon_y, int i);

/*Draw one raindrop*/
void DrawRainDrop (int x, int y, int color);

/*Draw one snowdrop*/
void DrawSnowDrop (int x, int y, int color);

/*Draw one haildrop*/
void DrawHailDrop (int x, int y, int color);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int* current_precip, int* current_color,
		           int* clear_weather, int* day_or_night, int* animation);

/*****************************************************************************

     MAIN

*****************************************************************************/

/* Main() has two chief purposes: to contain the important variables and 
   initialize them, and to contain the "event loop," which constantly looks 
   to see if an event has happened, and then processes the event by calling 
   an appropriate function.
*/

int main(void)
{

  int quit = FALSE;
  int mouse_x;
  int mouse_y;
  char key_hit;
  
  /*The distance the crab moves each time*/
  int cc=5;

  /*The distance the waves move each time*/ 
  int ff= 10;

  /*The distance the bird moves each time*/
  int aa= 5;

  /*The distance the ship moves each time*/
  int ss = 10;

  /*The distance the snow-man moves*/
  int ii = 10;

  /*The starting point of the sun*/
  int sun_x =GP142_XMAX - 30, sun_y = GP142_YMAX - 80;
  
  /*The starting point of the shooting star*/
  int star_x = GP142_XMAX-60, star_y= GP142_YMAX-80;

  /*The starting point of the moon*/
  int moon_x = 180, moon_y= 170;
 
  /* The next items tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
  int precip_type[MAX_PRECIP_EVENTS];
  int bottom_x [MAX_PRECIP_EVENTS];
  int bottom_y [MAX_PRECIP_EVENTS];
  int precip_color [MAX_PRECIP_EVENTS];
  
  /*The current amount of precipitation*/
  int current_object = 0;
  
  /*The first color of the printf statements*/
  int abc = 0;
  int windy = 0;
  
  /*Set the daytime to the program first 
    whenever the program starts and restarts*/
  int day_or_night = DAY;

  /*Clear the animation effect*/
  int animation = RESTART;

  /*Initialize the clear_weather to FALSE first*/
  int clear_weather = FALSE;

  /*Initialize the current_precip & current_color to NONE first*/
  int current_precip = NONE, current_color = NONE; 
  
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;

  /*What kind of click was there?*/
  int mouse_click;

  /*The most recent GP142 event*/
  int event; 
 
  /*Initialize waves' move to 0*/
  int n= 0;

  /*Initialize bird's move vertically 0*/
  int a =0;

  /*Initialize bird's move horizontally to 0*/
  int b = 0;

  /*Initialize crab's move to 0*/
  int c = 0;

  /*Initialize ship's move to 0*/
  int s = 0;

  /*Initialize snow-man's move to 0*/
  int i = 0;   
  
  /*Open and init the GP142 Graphics Window */
  GP142_open(); 

  /*This will log off the window*/
  GP142_logging(LOG_OFF); 

  /*This will clear the window & paint it white.*/
  GP142_clear();	    
  
  /*Start animation so precips will grow*/
  GP142_animate(ANI_RUN); 

  /*Show the Landscape*/
  DrawLandscape(sun_x, sun_y,day_or_night, star_x, star_y,  n, a,b, 
				animation,c,s, moon_x, moon_y,i);

  /* Show the buttons...*/ 
  DrawButtons(current_precip, current_color, day_or_night, 
	          animation, clear_weather);	 

  /*This will clear the precips*/
  ClearAllPrecipitation (precip_type);
  

  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop */
      break;

    case GP142_KBD:
	  /*not needed for this program.*/
	  /*Use this if user will need to hit a key.*/

      break;

    case GP142_MOUSE:
	  /* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);

	if (mouse_click == BUTTON) {
	  /* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, &current_precip, &current_color, 
			          &clear_flag, &day_or_night, &animation);
 
		if (clear_flag == TRUE){
			ClearAllPrecipitation(precip_type);
			current_object=0;
		}

	} else if ((mouse_click != DIRT)&& (current_precip != NONE) && 
			   (current_color != NONE)){
	  /*It's not a button, and it's not the dirt, so it must be sky*/
	
	  /* At this point we know everything we need to know about a drop.
	     We assign the current position and current selection of color
		 and precip to the appropriate array
		 */
		
		
		bottom_x[current_object] = mouse_x;
		bottom_y[current_object] = mouse_y;
		precip_type[current_object] = current_precip;
		precip_color[current_object] = current_color;

	  /*Draw a precipitation*/
		DrawAllPrecipitation(precip_type, bottom_x, 
					bottom_y, precip_color, current_object);
		
		current_object = current_object + 1;
	}
      
      break;

    case GP142_PERIODIC:
      	/*Some time has passed, 
		so make all the precipitation a little lower*/

		for (i=0; i < current_object; i++)
		{
            /*Raindrop with animation applied*/
			if (animation == WINDY && precip_type[i] == RAIN)
			{

				bottom_x[i] = bottom_x[i] + 7;	
				bottom_y[i] = bottom_y[i] - 5;
			
				if (bottom_y[i] < -GP142_YMAX - 40)
				{
					bottom_y[i] = -bottom_y[i];
				}
				if (bottom_x[i] > GP142_XMAX + 40)
				{
					bottom_x[i] = -bottom_x[i];
				}
			}

			else 
			{
			
				bottom_y[i] = bottom_y[i] - 5;
				
				if (bottom_y[i] < -GP142_YMAX - 40){
				bottom_y[i] = -bottom_y[i];
				bottom_x[i] = bottom_x[i] - 10;
				}
			}

			/*Snowdrop with animation applied*/
			if (animation == WINDY && precip_type[i] == SNOW)

			{

				bottom_x[i] = bottom_x[i] + 8;	
				bottom_y[i] = bottom_y[i] - 1;
			
				if (bottom_y[i] < -GP142_YMAX - 40)
				{
					bottom_y[i] = -bottom_y[i];
                
				}
				if (bottom_x[i] > GP142_XMAX + 40)
				{
					bottom_x[i] = -bottom_x[i] ;

				}


			}

			else 
			{
			
				bottom_y[i] = bottom_y[i] - 1;
				
				if (bottom_y[i] < -GP142_YMAX - 40){
				bottom_y[i] = -bottom_y[i];
				bottom_x[i] = bottom_x[i] - 10;
				}
			}


			/*Haildrop with animation applied*/
			if (animation == WINDY && precip_type[i] == HAIL)

			{

				bottom_x[i] = bottom_x[i] + 8;	
				bottom_y[i] = bottom_y[i] - 3;
			
				if (bottom_y[i] < -GP142_YMAX - 40)
				{
					bottom_y[i] = -bottom_y[i];
          		}

				if(bottom_x[i] > GP142_XMAX + 40)
				{
					bottom_x[i] = -bottom_x[i] ;
				}

			}

			else 
			{
			
				bottom_y[i] = bottom_y[i] - 3;
				
				if (bottom_y[i] < -GP142_YMAX - 40){
				bottom_y[i] = -bottom_y[i];
				bottom_x[i] = bottom_x[i] - 10;
				}
			}






		}

		/*The first printf statment without animation applied*/
        if (animation != WINDY){

		abc++;
		if (abc > 20)
			abc = 0;
		}
		/*The second printf statement with animation applied*/
		if (animation == WINDY){

			windy++;
			if (windy > 20)
				windy = 0;

	    /* snow-man falls down */
		
			i = i + ii;
			if (i == 400)
				ii = ii * -1;
			if (i == 0)
				ii = ii * -1;
			if(i >550 || i < -550)
		        i = 0;
		}


					
	    /* waves move */	
		
			n = n + ff;
			if (n == 300)
				ff = ff * -1;
			if (n == 0)
				ff = ff * -1;
			
			if (n > 500 || n < -500)
				n = 0;
		
		/* ship moves */
       
			s = s + ss;
			if (s == 350)
				ss = ss * -1;
			if (s == 0)
				ss = ss * -1;
			if (s >550 || s < -550)
				s = 0;

		/* bird moves */	

			b = b + aa;
			a = a - aa;
			if (b == 350)
				aa = aa * -1;
			
			if (b == 0 && a==0)
			    aa = aa * -1;
		   
			if (b > 700 || b < -700)
				b = 0;
			if (a > 700 || a < -700)
				a = 0;
			
		/* crab moves */
			
			c = c + cc;
			if (c == 400)
				cc = cc * -1;
			if (c == 0)
				cc = cc * -1;
	
			

	

		/*change the sun's position a little bit*/
			sun_x = sun_x - 5;
			sun_y = sun_y - 3;
			
			if (sun_x < -GP142_XMAX -500) {
				sun_x =  GP142_XMAX-10;
				sun_y = GP142_YMAX-10 ;
				
			}
	
	
		/*Change the position of the star*/
			star_x = star_x-20;
			star_y = star_y-5;
			
			if (star_x < -GP142_XMAX-1600){
				star_x = GP142_XMAX-10;
				star_y = GP142_YMAX-10;
			}
	
        /* change the position of the moon */
			moon_x = moon_x - 3;
			moon_y = moon_y;
			
			if ( moon_x < -GP142_XMAX-10){
				moon_x = GP142_XMAX-10;
			}
      break;

    default:

      break;
	
    }  /*end switch */
	

    /* Redraw everything */
    DrawLandscape(sun_x, sun_y, day_or_night, star_x, star_y,  n, a, b, 
				  animation, c, s, moon_x, moon_y, i);
    DrawButtons(current_precip, current_color, day_or_night, animation, 
				clear_weather);
    DrawAllPrecipitation(precip_type, bottom_x,bottom_y, precip_color,
						 current_object);
	GP142_printfXY(abc, -120, 220, 20, "The number of precipitation is %d!!!\n",
				   current_object);

    GP142_printfXY (abc, -200, 200,18, "Click a weather type");
	GP142_printfXY(abc,-40,200,18," and a color,then click on the picture.");

	if (animation == WINDY)
	GP142_printfXY(windy, -170, 160, 30, "Be careful with the stormy wind!!");

	
	
  }/* end event loop */

/* clean up and close graphics window   */
  GP142_close();        
  return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


/*reinitialize so that ALL current precipitation is erased.*/
void  ClearAllPrecipitation(int precip_type[])
{
	int i;
  for (i = 0; i < MAX_PRECIP_EVENTS; i++)
  precip_type[i] = NONE;
}



/*Draw raindrop*/
#define RAINDROP_WIDTH 5

void DrawRainDrop (int x, int y, int color) { 
	
	
	GP142_circleXY(color, x, y , RAINDROP_WIDTH/2 );
    GP142_triangleXY(color, x, y+10, x+ RAINDROP_WIDTH/2, 
					 y+RAINDROP_WIDTH/2,x-RAINDROP_WIDTH/2, 
					 y-RAINDROP_WIDTH/2, 0);
}

/*Draw snowdrop*/
#define SNOWDROP_WIDTH 6
#define SNOWDROP_HEIGHT 7

void DrawSnowDrop (int x, int y, int color) {


	GP142_rectangleXY(color, x, y, x+SNOWDROP_WIDTH, 
					  y+SNOWDROP_HEIGHT, FILL); 
	GP142_lineXY(color, x-2,y-2,x+SNOWDROP_WIDTH+2, 
				 y+SNOWDROP_HEIGHT+2, 2);
    GP142_lineXY(color, x-2, y+SNOWDROP_HEIGHT+2,
				 x+SNOWDROP_WIDTH+2, y-2, 2);
	GP142_lineXY(color, x-2,y+SNOWDROP_HEIGHT/2,
				 x+SNOWDROP_WIDTH+2, y+SNOWDROP_HEIGHT/2, 2);
    GP142_lineXY(color, x+SNOWDROP_WIDTH/2, y+SNOWDROP_HEIGHT+2,
				 x+SNOWDROP_WIDTH/2, y-2 , 2);

}

/*Draw haildrop*/
#define HAILDROP_WIDTH 7
#define HAILDROP_HEIGHT 9

void DrawHailDrop (int x, int y, int color){

	GP142_ovalXY(color, x, y, x + HAILDROP_WIDTH, y + HAILDROP_HEIGHT, FILL);
}

void DrawAllPrecipitation(int precip_type[], 
						  int x[], 
						  int y[], 
						  int precip_color[], 
						  int current_object)
{
    /*count the number of precipiation*/
	int i;

	
		
		for (i=0; i < current_object; i++){
			
			
			if (y[i] >= TOP_OF_DIRT - 20) {
				
				switch (precip_type[i]) {
				
				case RAIN:
					DrawRainDrop (x[i], y[i], precip_color[i]);
					break;
				case SNOW:
					DrawSnowDrop (x[i], y[i], precip_color[i]);
					break;
				case HAIL:
					DrawHailDrop (x[i], y[i], precip_color[i]);
				default:
				
				{}
				
				} /* end switch*/
			}	
		
		}

		
	


}



/*Get the location of the current precipitation*/
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}

/*Draw the landscape*/
void DrawLandscape(int sun_x, int sun_y, int day_or_night, 
				   int star_x, int star_y, int n,  int a, int b
				   ,int animation, int c, int s, 
				   int moon_x, int moon_y, int i)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;
  

  /* Draw the sky first if it is at night*/
  if (day_or_night == NIGHT){    
        GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
            GP142_XMAX, GP142_YMAX, FILL);        
		

  /* Draw the bird */

  GP142_circleXY(RED, -GP142_XMAX+250+b, GP142_YMAX-80+a, 10);
  GP142_circleXY(BLACK, -GP142_XMAX+250+b, GP142_YMAX-85+a, 10);
  GP142_circleXY(WHITE, -GP142_XMAX+270+b, GP142_YMAX-80+a, 10);
  GP142_circleXY(BLACK, -GP142_XMAX+270+b, GP142_YMAX-85+a, 10);
  GP142_lineXY(WHITE, -GP142_XMAX + 250+b, GP142_YMAX -80+a, 
			   -GP142_XMAX+270+b,GP142_YMAX-80+a,3);


  /* draw moon */
    
	GP142_circleXY(YELLOW, moon_x, moon_y, 20);
    GP142_circleXY(BLACK, moon_x-30, moon_y, 30);

  /* Draw shooting-star*/
		
	GP142_circleXY(YELLOW,star_x,star_y,2);
	GP142_lineXY(YELLOW, star_x, star_y, star_x+50, star_y+7, 1);
	GP142_lineXY(YELLOW, star_x, star_y-1, star_x+50, star_y+9, 1);
	GP142_lineXY(YELLOW, star_x, star_y-2, star_x+50, star_y+4, 1);
	GP142_lineXY(YELLOW, star_x, star_y-3, star_x+60, star_y+10, 1);
	GP142_lineXY(YELLOW, star_x, star_y+1, star_x+60, star_y+11, 1);
	GP142_lineXY(YELLOW, star_x, star_y+2, star_x+50, star_y+12, 1);
	GP142_lineXY(YELLOW, star_x, star_y+3, star_x+60, star_y+3, 1);
	GP142_lineXY(YELLOW, star_x, star_y+4, star_x+30, star_y+2, 1);
	GP142_lineXY(YELLOW, star_x, star_y, star_x+70, star_y, 1);
	GP142_lineXY(YELLOW, star_x, star_y, star_x+70, star_y-2, 1);
	GP142_lineXY(YELLOW, star_x+10, star_y+5, star_x+50, star_y+7, 1);


  /*twinkling Stars*/    

	if (((sun_y % 8) <= 4) && ((sun_y % 8) >= -4)){
        
		GP142_pixelXY(WHITE, -120, 250);        
		GP142_pixelXY(WHITE, 50, 120);
        GP142_pixelXY(WHITE, -190, 100);        
		GP142_pixelXY(WHITE, 10, 95);
		GP142_pixelXY(WHITE, 200, 120);
		GP142_pixelXY(WHITE, -90, -100);
		GP142_pixelXY(WHITE, 240, 130);
        GP142_pixelXY(WHITE, 240, 150);
		}   
    
	else if (((sun_y % 8) <= 8) || ((sun_y % 8) <= -5))    {   
    
		GP142_pixelXY(WHITE, 150, -100);        
		GP142_pixelXY(WHITE, -60, 200);
        GP142_pixelXY(WHITE, -160, 120);        
		GP142_pixelXY(WHITE, 50, 100);
		GP142_pixelXY(WHITE, 90, -140);
		GP142_pixelXY(WHITE, 120, -100);
		GP142_pixelXY(WHITE, 210, 100);
		GP142_pixelXY(WHITE, 200, 110);
    }

  	
	if (animation == WINDY){	
  /* Draw Clouds */
  
	GP142_lineXY(WHITE, -GP142_XMAX+100, GP142_YMAX-90, 
				-GP142_XMAX+80, GP142_YMAX-130, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+120, GP142_YMAX-90, 
				-GP142_XMAX+100, GP142_YMAX-140, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+140, GP142_YMAX-90, 
				-GP142_XMAX+110, GP142_YMAX-160, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+160, GP142_YMAX-90, 
				-GP142_XMAX+140, GP142_YMAX-140, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+180, GP142_YMAX-90, 
				-GP142_XMAX+160, GP142_YMAX-140, 3);

	GP142_circleXY(WHITE, -GP142_XMAX+75, GP142_YMAX-130, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+92, GP142_YMAX-140, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+118, GP142_YMAX-160, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+145, GP142_YMAX-140, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+168, GP142_YMAX-140, 8);


	GP142_circleXY(BLACK, -GP142_XMAX+75, GP142_YMAX-127, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+92, GP142_YMAX-137, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+118, GP142_YMAX-157, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+145, GP142_YMAX-137, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+168, GP142_YMAX-137, 5);




    GP142_circleXY(LT_GRAY, -GP142_XMAX+120, GP142_YMAX-80, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+130, GP142_YMAX-85, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+120, GP142_YMAX-90, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+140, GP142_YMAX-80, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+140, GP142_YMAX-65, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+160, GP142_YMAX-90, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+180, GP142_YMAX-90, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+170, GP142_YMAX-60, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+100, GP142_YMAX-90, 20);


    GP142_circleXY(LT_GRAY, -GP142_XMAX+350, GP142_YMAX-100, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+370, GP142_YMAX-100, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+390, GP142_YMAX-90, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+410, GP142_YMAX-100, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+430, GP142_YMAX-100, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+410, GP142_YMAX-110, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+370, GP142_YMAX-110, 20);
    GP142_circleXY(LT_GRAY, -GP142_XMAX+390, GP142_YMAX-110, 20);		
	

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
	GP142_rectangleXY(FOREST_GREEN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT+30, FILL);



  /* snow_man fall down */
    GP142_circleXY(WHITE, -GP142_XMAX+250+i, TOP_OF_DIRT, 30);
    GP142_circleXY(WHITE, -GP142_XMAX+150+i, -GP142_YMAX+190, 60);
    GP142_circleXY(BLACK, -GP142_XMAX+270+i, TOP_OF_DIRT+10, 4);
    GP142_circleXY(BLACK, -GP142_XMAX+260+i, TOP_OF_DIRT+5, 4);
    GP142_triangleXY(ORANGE, -GP142_XMAX+270+i, TOP_OF_DIRT-10, 
					 -GP142_XMAX+270+i, TOP_OF_DIRT, 
	                 -GP142_XMAX+320+i, TOP_OF_DIRT, FILL);
    GP142_rectangleXY(CYAN, -GP142_XMAX+210+i, -GP142_YMAX+205, 
					  -GP142_XMAX+290+i, -GP142_YMAX+210, 0);
    GP142_rectangleXY(GREEN, -GP142_XMAX+220+i, -GP142_YMAX+210, 
		              -GP142_XMAX+280+i, -GP142_YMAX+230, 0);

		}
  

	if (animation != WINDY){		
  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
	GP142_rectangleXY(FOREST_GREEN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT+30, FILL);
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");


  /* Draw the snow-man */
 
	GP142_circleXY(WHITE, -GP142_XMAX+150, TOP_OF_DIRT+80, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+150, -GP142_YMAX+190, 60);
	GP142_circleXY(BLACK, -GP142_XMAX+170, TOP_OF_DIRT+90, 4);
	GP142_circleXY(BLACK, -GP142_XMAX+160, TOP_OF_DIRT+85, 4);
	GP142_triangleXY(ORANGE, -GP142_XMAX+170, TOP_OF_DIRT+70, 
					 -GP142_XMAX+170, TOP_OF_DIRT+80, 
	                 -GP142_XMAX+220, TOP_OF_DIRT+80, FILL);
	GP142_rectangleXY(CYAN, -GP142_XMAX+110, -GP142_YMAX+285, 
					  -GP142_XMAX+190, -GP142_YMAX+290, 0);
	GP142_rectangleXY(GREEN, -GP142_XMAX+120, -GP142_YMAX+290, 
					  -GP142_XMAX+180, -GP142_YMAX+310, 0);

		}
  
  /* Draw the house*/

	GP142_rectangleXY(PURPLE, -GP142_XMAX+300, -GP142_YMAX+ 120, 
					  GP142_XMAX-70, TOP_OF_DIRT + 20 ,0);
	GP142_rectangleXY(YELLOW, -GP142_XMAX+300, TOP_OF_DIRT+20 ,
					  GP142_XMAX-70, TOP_OF_DIRT + 50 ,0);
	GP142_rectangleXY(RED, -GP142_XMAX+300, TOP_OF_DIRT+50 , GP142_XMAX-70, 
					  TOP_OF_DIRT + 120 ,0);
	GP142_triangleXY(RED, -GP142_XMAX+300, TOP_OF_DIRT+50, -GP142_XMAX+260,
					 TOP_OF_DIRT+50, -GP142_XMAX+300, TOP_OF_DIRT+100,0);
	GP142_triangleXY(RED, GP142_XMAX-70, TOP_OF_DIRT+50, GP142_XMAX-70,
					 TOP_OF_DIRT+100, GP142_XMAX-30, TOP_OF_DIRT+50,0);	  
	GP142_circleXY(BLUE, -GP142_XMAX+350, -GP142_YMAX+ 200, 30);
	GP142_rectangleXY(BLUE, -GP142_XMAX+320, -GP142_YMAX+ 120, -GP142_XMAX+380, 
					  -GP142_YMAX+190 ,0);
	GP142_circleXY(BLACK, -GP142_XMAX+330, -GP142_YMAX+ 170, 5);
	GP142_rectangleXY(BLUE, -GP142_XMAX+400, -GP142_YMAX+ 150,
					  -GP142_XMAX+500, -GP142_YMAX+200 ,0);
	GP142_lineXY(BLACK, -GP142_XMAX+400, -GP142_YMAX+175, -GP142_XMAX+500, 
				 -GP142_YMAX+175,3);
	GP142_lineXY(BLACK, -GP142_XMAX+450, -GP142_YMAX+150, -GP142_XMAX+450, 
				 -GP142_YMAX+200,3);
 
 


  }




  if (day_or_night == DAY){
	  
	  GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
	  
 
  /* Draw Rainbow */
	GP142_ovalXY(RED, -GP142_XMAX+90, -GP142_YMAX+200, -GP142_XMAX+500, 
				 -GP142_YMAX+450, 12);
	GP142_ovalXY(ORANGE, -GP142_XMAX+90, -GP142_YMAX+190, -GP142_XMAX+500, 
				 -GP142_YMAX+440, 12);
	GP142_ovalXY(YELLOW, -GP142_XMAX+90, -GP142_YMAX+180, -GP142_XMAX+500, 
				 -GP142_YMAX+430, 12);
	GP142_ovalXY(FOREST_GREEN, -GP142_XMAX+90, -GP142_YMAX+170, -GP142_XMAX+500, 
				 -GP142_YMAX+420, 12);
	GP142_ovalXY(GREEN, -GP142_XMAX+90, -GP142_YMAX+160, -GP142_XMAX+500, 
				 -GP142_YMAX+410, 12);
	GP142_ovalXY(BLUE, -GP142_XMAX+90, -GP142_YMAX+150, -GP142_XMAX+500, 
				 -GP142_YMAX+400, 12);
	GP142_ovalXY(PURPLE, -GP142_XMAX+90, -GP142_YMAX+140, -GP142_XMAX+500, 
				 -GP142_YMAX+390, 12);
	GP142_ovalXY(ICE_BLUE, -GP142_XMAX+90, -GP142_YMAX+130, -GP142_XMAX+500, 
				 -GP142_YMAX+380, 0);
  
  
  
	GP142_circleXY(WHITE, -GP142_XMAX+80, GP142_YMAX-220, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+120, GP142_YMAX-200, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+120, GP142_YMAX-215, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+140, GP142_YMAX-200, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+140, GP142_YMAX-205, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+160, GP142_YMAX-220, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+100, GP142_YMAX-240, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+130, GP142_YMAX-240, 30); 
	GP142_circleXY(ICE_BLUE, -GP142_XMAX+100, GP142_YMAX-300, 30);

	GP142_circleXY(WHITE, -GP142_XMAX+470, GP142_YMAX-180, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+510, GP142_YMAX-160, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+510, GP142_YMAX-175, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+530, GP142_YMAX-160, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+530, GP142_YMAX-175, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+550, GP142_YMAX-180, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+490, GP142_YMAX-200, 30);
	GP142_circleXY(WHITE, -GP142_XMAX+520, GP142_YMAX-200, 30); 
	GP142_circleXY(ICE_BLUE, -GP142_XMAX+500, GP142_YMAX-300, 30);
	GP142_circleXY(ICE_BLUE, -GP142_XMAX+500, GP142_YMAX-258, 30);


  /* Draw bird*/
	GP142_circleXY(BLACK, -GP142_XMAX+250+b, GP142_YMAX-180+a, 10);
	GP142_circleXY(ICE_BLUE, -GP142_XMAX+250+b, GP142_YMAX-185+a, 10);
	GP142_circleXY(BLACK, -GP142_XMAX+270+b, GP142_YMAX-180+a, 10);
	GP142_circleXY(ICE_BLUE, -GP142_XMAX+270+b, GP142_YMAX-185+a, 10);
	GP142_lineXY(BLACK, -GP142_XMAX + 250+b, GP142_YMAX -180+a, 
				 -GP142_XMAX+270+b,GP142_YMAX-180+a,3);

  /* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 25);
	GP142_lineXY(RED, sun_x+30, sun_y, sun_x+45, sun_y, 4);
	GP142_lineXY(RED, sun_x-30, sun_y, sun_x-45, sun_y, 4);
	GP142_lineXY(RED, sun_x+30, sun_y+20, sun_x+42, sun_y+35, 4);
	GP142_lineXY(RED, sun_x-30, sun_y+20, sun_x-42, sun_y+35, 4);
	GP142_lineXY(RED, sun_x, sun_y+30, sun_x, sun_y+45, 4);
	GP142_lineXY(RED, sun_x, sun_y-30, sun_x, sun_y-45, 4);
	GP142_lineXY(RED, sun_x+30, sun_y-20, sun_x+45, sun_y-35, 4);
	GP142_lineXY(RED, sun_x-30, sun_y-20, sun_x-45, sun_y-35, 4);

  

  /* Draw the sea*/ 
	GP142_rectangleXY(NAVY_BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT-30, FILL);

  /* Draw wave 1 */
	GP142_circleXY(WHITE, -GP142_XMAX+200+n, TOP_OF_DIRT-80, 10);
	GP142_circleXY(NAVY_BLUE, -GP142_XMAX+200+n, TOP_OF_DIRT-85 , 10);
	GP142_circleXY(WHITE, -GP142_XMAX + 220+n, TOP_OF_DIRT-75, 10);
	GP142_circleXY(NAVY_BLUE, -GP142_XMAX+220+n, TOP_OF_DIRT-70, 10);

 



  /* Draw the ship */
	GP142_rectangleXY(RED, -GP142_XMAX +30+ s, -GP142_YMAX +80, 
					  -GP142_XMAX+110+s, -GP142_YMAX+110, 0);
	GP142_triangleXY(RED, -GP142_XMAX+30+s,-GP142_YMAX +80 , -
					 GP142_XMAX+100+s, -GP142_YMAX+110, -GP142_XMAX+5+s,
					 -GP142_YMAX+115 ,0);
	GP142_triangleXY(RED, -GP142_XMAX+100+s,-GP142_YMAX +110 ,
					 -GP142_XMAX+100+s, -GP142_YMAX+80, -GP142_XMAX+140+s,
					 -GP142_YMAX+120 ,0);
 
  
	GP142_triangleXY(YELLOW, -GP142_XMAX+70+s,-GP142_YMAX +125 , 
					 -GP142_XMAX+70+s, -GP142_YMAX+190, -GP142_XMAX+20+s,
					 -GP142_YMAX+125 ,0);
	GP142_triangleXY(PURPLE, -GP142_XMAX+70+s,-GP142_YMAX +120 , 
					 -GP142_XMAX+70+s, -GP142_YMAX+210, -GP142_XMAX+130+s,
					 -GP142_YMAX+130 ,0);
	GP142_lineXY(BLACK, -GP142_XMAX+70+s, -GP142_YMAX+115, -GP142_XMAX+70+s, 
					 -GP142_YMAX+210, 5);

  /* Draw wave 2 */
	GP142_circleXY(WHITE, -GP142_XMAX+250+n, TOP_OF_DIRT-130, 10);
	GP142_circleXY(NAVY_BLUE, -GP142_XMAX+250+n, TOP_OF_DIRT-135 , 10);
	GP142_circleXY(WHITE, -GP142_XMAX + 270+n, TOP_OF_DIRT-125, 10);
	GP142_circleXY(NAVY_BLUE, -GP142_XMAX+270+n, TOP_OF_DIRT-120, 10);
  
  /* Draw crab */
	GP142_ovalXY(ORANGE, -GP142_XMAX+180+c, -GP142_YMAX+30, 
				 -GP142_XMAX+220+c, -GP142_YMAX+60, FILL);
	GP142_circleXY(BLACK, -GP142_XMAX+190+c, -GP142_YMAX+60, 3);
	GP142_circleXY(BLACK, -GP142_XMAX+210+c, -GP142_YMAX+60, 3);
	GP142_circleXY(BLACK, -GP142_XMAX+210+c, -GP142_YMAX+45, 8);
	GP142_circleXY(ORANGE, -GP142_XMAX+213+c, -GP142_YMAX+45, 8);
	GP142_circleXY(BLACK, -GP142_XMAX+190+c, -GP142_YMAX+45, 8);
	GP142_circleXY(ORANGE, -GP142_XMAX+187+c, -GP142_YMAX+45, 8);
  
	GP142_lineXY(ORANGE, -GP142_XMAX+184+c, -GP142_YMAX+50, 
				 -GP142_XMAX+178+c, -GP142_YMAX+60, 4);
	GP142_lineXY(ORANGE, -GP142_XMAX+218+c, -GP142_YMAX+50, 
				 -GP142_XMAX+224+c, -GP142_YMAX+60, 4);
	GP142_lineXY(ORANGE, -GP142_XMAX+178+c, -GP142_YMAX+60, 
				 -GP142_XMAX+187+c, -GP142_YMAX+69, 4);
	GP142_lineXY(ORANGE, -GP142_XMAX+224+c, -GP142_YMAX+60, 
				 -GP142_XMAX+214+c, -GP142_YMAX+69, 4);

	GP142_lineXY(ORANGE, -GP142_XMAX+180+c, -GP142_YMAX+45, 
				 -GP142_XMAX+165+c, -GP142_YMAX+48, 4);
	GP142_lineXY(ORANGE, -GP142_XMAX+220+c, -GP142_YMAX+45, 
				 -GP142_XMAX+235+c, -GP142_YMAX+48, 4);
	GP142_lineXY(ORANGE, -GP142_XMAX+182+c, -GP142_YMAX+35, 
				 -GP142_XMAX+162+c, -GP142_YMAX+31, 4);
	GP142_lineXY(ORANGE, -GP142_XMAX+219+c, -GP142_YMAX+35, 
				 -GP142_XMAX+238+c, -GP142_YMAX+31, 4);



  if (animation == WINDY){
  /* Draw Clouds */

	GP142_lineXY(WHITE, -GP142_XMAX+100, GP142_YMAX-90, 
				 -GP142_XMAX+80, GP142_YMAX-130, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+120, GP142_YMAX-90, 
				 -GP142_XMAX+100, GP142_YMAX-140, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+140, GP142_YMAX-90, 
				 -GP142_XMAX+110, GP142_YMAX-160, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+160, GP142_YMAX-90, 
				 -GP142_XMAX+140, GP142_YMAX-140, 3);
	GP142_lineXY(WHITE, -GP142_XMAX+180, GP142_YMAX-90, 
				 -GP142_XMAX+160, GP142_YMAX-140, 3);

	GP142_circleXY(WHITE, -GP142_XMAX+75, GP142_YMAX-130, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+92, GP142_YMAX-140, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+118, GP142_YMAX-160, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+145, GP142_YMAX-140, 8);
	GP142_circleXY(WHITE, -GP142_XMAX+168, GP142_YMAX-140, 8);


	GP142_circleXY(BLACK, -GP142_XMAX+75, GP142_YMAX-127, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+92, GP142_YMAX-137, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+118, GP142_YMAX-157, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+145, GP142_YMAX-137, 5);
	GP142_circleXY(BLACK, -GP142_XMAX+168, GP142_YMAX-137, 5);


	GP142_circleXY(LT_GRAY, -GP142_XMAX+120, GP142_YMAX-80, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+130, GP142_YMAX-85, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+120, GP142_YMAX-90, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+140, GP142_YMAX-80, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+140, GP142_YMAX-65, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+160, GP142_YMAX-90, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+180, GP142_YMAX-90, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+170, GP142_YMAX-60, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+100, GP142_YMAX-90, 20);



  

	GP142_circleXY(LT_GRAY, -GP142_XMAX+300, GP142_YMAX-100, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+320, GP142_YMAX-100, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+340, GP142_YMAX-90, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+360, GP142_YMAX-100, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+380, GP142_YMAX-100, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+360, GP142_YMAX-110, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+320, GP142_YMAX-110, 20);
	GP142_circleXY(LT_GRAY, -GP142_XMAX+340, GP142_YMAX-110, 20);
  }
 

  }
  
 

} /*end DrawLandscape */


/* Figure out which button was clicked */
void handle_button(int x, int y, int* current_precip, int* current_color,
				   int* clear_weather, int* day_or_night, int* animation)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  
	  
	  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  case 2:
	*current_precip = HAIL;
	break;
  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = BLUE;
    break;
  case 5:
	*current_color = PURPLE;
	break;
  case 6:
	*day_or_night = DAY;
	break;
  case 7:
	*day_or_night = NIGHT;
	break;
  case 8:
	*animation = WINDY;
	break;
  case 9:
    *animation = RESTART;
  case 10:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
	  {}
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color, int day_or_night, 
				 int animation, int clear_weather)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 18;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Rain");	


  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Snow");
  

  i -= BUTTON_HEIGHT;
  if (current_precip == HAIL)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Hail");
  else
	GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Hail");


  /* _Buttons for Colors */
 
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "White");

 
  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Blue");

  i -= BUTTON_HEIGHT;
  if (current_color == PURPLE)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Purple");
  else
	GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Purple");
	
  i -= BUTTON_HEIGHT;
  if (day_or_night == DAY)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Day");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Day");

  i -= BUTTON_HEIGHT;
  if (day_or_night == NIGHT)	
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Night");
  else
	GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Night");

  i -= BUTTON_HEIGHT;
  if (animation == WINDY)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Windy");
  else 
	GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Windy");
  
 
  i -= BUTTON_HEIGHT;
	
  if (clear_weather == TRUE)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Restart");
  else
   	GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Restart");
}




